/*
 * BlizzLikeCore Copyright (C) 2013  BlizzLikeGroup
 * Integrated Files: CREDITS.md and LICENSE.md
 */

/* ScriptData
Name: Boss_Celebras_the_Cursed
Complete(%): 100
Comment:
Category: Maraudon
EndScriptData */

#include "ScriptPCH.h"

#define SPELL_WRATH                 21807
#define SPELL_ENTANGLINGROOTS       12747
#define SPELL_CORRUPT_FORCES        21968

struct celebras_the_cursedAI : public ScriptedAI
{
    celebras_the_cursedAI(Creature* c) : ScriptedAI(c) {}

    uint32 Wrath_Timer;
    uint32 EntanglingRoots_Timer;
    uint32 CorruptForces_Timer;

    void Reset()
    {
        Wrath_Timer = 8000;
        EntanglingRoots_Timer = 2000;
        CorruptForces_Timer = 30000;
    }

    void EnterCombat(Unit* /*who*/) { }

    void JustDied(Unit* /*Killer*/)
    {
        me->SummonCreature(13716, me->GetPositionX(), me->GetPositionY(), me->GetPositionZ(), 0, TEMPSUMMON_TIMED_DESPAWN, 600000);
    }

    void UpdateAI(const uint32 diff)
    {
        if (!UpdateVictim())
            return;

        //Wrath
        if (Wrath_Timer <= diff)
        {
            Unit* pTarget = NULL;
            pTarget = SelectUnit(SELECT_TARGET_RANDOM,0);
            if (pTarget)
                DoCast(pTarget, SPELL_WRATH);
            Wrath_Timer = 8000;
        } else Wrath_Timer -= diff;

        //EntanglingRoots
        if (EntanglingRoots_Timer <= diff)
        {
            DoCast(me->getVictim(), SPELL_ENTANGLINGROOTS);
            EntanglingRoots_Timer = 20000;
        } else EntanglingRoots_Timer -= diff;

        //CorruptForces
        if (CorruptForces_Timer <= diff)
        {
            me->InterruptNonMeleeSpells(false);
            DoCast(me, SPELL_CORRUPT_FORCES);
            CorruptForces_Timer = 20000;
        } else CorruptForces_Timer -= diff;

        DoMeleeAttackIfReady();
    }
};
CreatureAI* GetAI_celebras_the_cursed(Creature* pCreature)
{
    return new celebras_the_cursedAI (pCreature);
}

void AddSC_boss_celebras_the_cursed()
{
    Script *newscript;
    newscript = new Script;
    newscript->Name = "celebras_the_cursed";
    newscript->GetAI = &GetAI_celebras_the_cursed;
    newscript->RegisterSelf();
}

